=== debian/control ===
Source: lagrange
Section: net
Priority: optional
Maintainer: Jaakko Keränen (skyjake) <jaakko.keranen@iki.fi>
Build-Depends: cmake (>=3.9), debhelper (>=11~), libsdl2-dev (>=2.0.4), libssl-dev (>=1.1.1), libpcre3-dev (>=8.38), zlib1g-dev, libunistring-dev, libmpg123-dev
Standards-Version: 4.1.4
Homepage: https://gmi.skyjake.fi/lagrange/

Package: lagrange
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Lagrange - A Beautiful Gemini Client
 Lagrange is a desktop GUI client for browsing Geminispace.
 It offers modern conveniences familiar from web browsers, 
 such as smooth scrolling, inline image viewing, multiple 
 tabs, visual themes, Unicode fonts, bookmarks, history,
 and page outlines.
